<?

class SenderTriggerBlogComment extends \Bitrix\Sender\Trigger
{
	/*
	 * @return string
	 *
	 *  
	 */
	public function getName()
	{
		return ' ';
	}

	/*
	 * @return string
	 *
	 *   
	 */
	public function getCode()
	{
		return "my_blog_comment";
	}

	/*
	 * @return string
	 *
	 * ,   
	 */
	public function getEventModuleId()
	{
		return 'blog';
	}

	/*
	 * @return string
	 *
	 * ,   
	 */
	public function getEventType()
	{
		return "OnCommentAdd";
	}

	/*
	 * @return bool
	 *
	 *      ,
	 *     
	 */
	public static function canBeTarget()
	{
		return true;
	}

	/*
	 * @return array|\Bitrix\Main\DB\Result|\CDBResult
	 *
	 * ,    
	 *     
	 */
	public function getRecipient()
	{
		//    
		$event = $this->getParam('EVENT');
		//        AUTHOR_ID
		$authorId = $event[1]['AUTHOR_ID'];

		if($authorId)
		{
			//  email   ,  
			$user = \Bitrix\Main\UserTable::getRowById($authorId);
			if($user)
			{
				//      
				return array(
					'EMAIL' => $user['EMAIL'],
					'NAME' => $user['NAME'],
					'USER_ID' => $user['ID'],
				);
			}
		}

		//     ,    
		return false;
	}

	/*
	 * @return bool
	 *
	 * ,  ,      .
	 */
	public function filter()
	{
		//print_r($this->getParam('EVENT'));die();

		//    
		$event = $this->getParam('EVENT');
		$eventBlogId = $event[1]['BLOG_ID'];
		$eventPostText = $event[1]['POST_TEXT'];

		//    ,
		//    ,    
		$blogId = $this->getFieldValue('BLOG_ID');
		if($blogId && $blogId != $eventBlogId)
		{
			return false;
		}

		//    -,
		//      ,
		//    
		$stopList = $this->getFieldValue('POST_TEXT_STOP_LIST');
		if($stopList && $this->isCommentHaveWords($eventPostText, $stopList))
		{
			return false;
		}

		//     ,
		//      ,
		//    
		$runList = $this->getFieldValue('POST_TEXT_RUN_LIST');
		if($runList && !$this->isCommentHaveWords($eventPostText, $runList))
		{
			return false;
		}

		//      ,
		//    
		return true;
	}

	public function isCommentHaveWords($comment, $wordList)
	{
		$comment = strtolower($comment);
		$wordList = strtolower($wordList);
		$wordListArray = explode("\n", $wordList);
		foreach($wordListArray as $word)
		{
			if(strpos($comment, $word) !== false)
			{
				return true;
			}
		}

		return false;
	}


	/*
	 * @return string
	 *
	 *   
	 */
	public function getForm()
	{
		$blogId = $this->getFieldValue('BLOG_ID');
		$stopList = $this->getFieldValue('POST_TEXT_STOP_LIST', '');
		$runList = $this->getFieldValue('POST_TEXT_RUN_LIST', '');

		$blogList = array();
		$blogDb = CBlog::GetList(
			array('ID' => 'DESC'),
			array('ACTIVE' => 'Y'),
			false,
			false,
			array('NAME', 'ID')
		);
		while($blog = $blogDb->Fetch())
		{
			$blog['SELECTED'] = ($blog['ID'] == $blogId ? true : false);
			$blogList[] = $blog;
		}

		ob_start();
		?>
		<table>
			<tr>
				<td>:</td>
				<td>
					<select name="<?=$this->getFieldName('BLOG_ID');?>">
						<option value="">()</option>
						<?foreach($blogList as $blog):?>
							<option value="<?=htmlspecialcharsbx($blog['ID'])?>" <?=($blog['SELECTED'] ? 'selected' : '')?>>
								<?=htmlspecialcharsbx($blog['NAME'])?>
							</option>
						<?endforeach?>
					</select>
				</td>
			</tr>
			<tr>
				<td>   :<br>(  )</td>
				<td>
					<textarea name="<?=$this->getFieldName('POST_TEXT_RUN_LIST');?>"><?=htmlspecialcharsbx($runList)?></textarea>
				</td>
			</tr>
			<tr>
				<td>-  :<br>(  )</td>
				<td>
					<textarea name="<?=$this->getFieldName('POST_TEXT_STOP_LIST');?>"><?=htmlspecialcharsbx($stopList)?></textarea>
				</td>
			</tr>
		</table>
		<?
		$resultForm = ob_get_clean();

		return $resultForm;
	}

	/**
	 *    
	 * @return array
	 */
	public function getPersonalizeFields()
	{
		$eventData = $this->getParam('EVENT');
		return array(
			'BLOG_COMMENT_ID' => $eventData[0],
			'BLOG_POST_ID' => $eventData[1]['POST_ID'],
			'BLOG_ID' => $eventData[1]['BLOG_ID'],
		);
	}

	/**
	 *       
	 * @return array
	 */
	public static function getPersonalizeList()
	{
		return array(
			array(
				'CODE' => 'BLOG_ID',
				'NAME' => ' ',
				'DESC' => '  ,    '
			),
			array(
				'CODE' => 'BLOG_POST_ID',
				'NAME' => '  ',
				'DESC' => '   ,    '
			),
			array(
				'CODE' => 'BLOG_COMMENT_ID',
				'NAME' => ' ',
				'DESC' => '  ,    '
			),
		);
	}
}