<?

class SenderTriggerViewedProduct extends \Bitrix\Sender\TriggerConnectorClosed
{
	/*
	 * @return string
	 *
	 *  
	 */
	public function getName()
	{
		return '   ';
	}

	/*
	 * @return string
	 *
	 *   
	 */
	public function getCode()
	{
		return "my_viewed_product";
	}

	/*
	 * @return bool
	 *
	 *      ,
	 *     
	 */
	public static function canBeTarget()
	{
		return false;
	}

    /*
	 * @return bool
	 *
	 *      ,
	 */
    public static function canRunForOldData()
    {
        return true;
    }

	/*
	 * @return bool
	 *
	 * ,  ,      .
	 *
	 */
	public function filter()
	{
		\Bitrix\Main\Loader::includeModule('sale');
		\Bitrix\Main\Loader::includeModule('catalog');


		$days = $this->getFieldValue('DAYS_VIEW');
		if(!is_numeric($days))
		{
			$days = 1;
		}

		$dateFrom = new \Bitrix\Main\Type\DateTime;
		$dateTo = new \Bitrix\Main\Type\DateTime;

		$dateFrom->setTime(0, 0, 0)->add('-' . $days.' days');
		$dateTo->setTime(0, 0, 0)->add('-' . ($days - 1) . ' days');

        if($this->isRunForOldData())
        {
            $filter = array(
                '!DATE_VISIT' => null,
                '<DATE_VISIT' => $dateTo,
            );
        }
        else
        {
            $filter = array(
                '>DATE_VISIT' => $dateFrom,
                '<DATE_VISIT' => $dateTo,
            );
        }
        $filter['=SITE_ID'] = $this->getSiteId();
		$userListDb = \Bitrix\Catalog\CatalogViewedProductTable::getList(array(
			'select' => array('USER_ID' => 'FUSER.USER.ID', 'EMAIL' => 'FUSER.USER.EMAIL', 'NAME' => 'FUSER.USER.NAME'),
			'filter' => $filter,
			'group' => array('USER_ID', 'EMAIL', 'NAME'),
			'order' => array('FUSER.USER.ID' => 'ASC')
		));

		if($userListDb->getSelectedRowsCount() > 0)
		{
			//   
			//   
			$this->recipient = $userListDb;

			//  
			return true;
		}
		else
		{
			//   ,   
			return false;
		}
	}


	/*
	 * @return string
	 *
	 *   
	 */
	public function getForm()
	{
		return '
			<table>
				<tr>
					<td>  :</td>
					<td>
						<input size=3 type="text" name="'.$this->getFieldName('DAYS_VIEW').'" value="'.htmlspecialcharsbx($this->getFieldValue('DAYS_VIEW', 90)).'">
					</td>
				</tr>
			</table>
		';
	}


	/*
	 * @return array|\Bitrix\Main\DB\Result|\CDBResult
	 *
	 * ,    
	 *     
	 */
	public function getRecipient()
	{
		//   
		return $this->recipient;
	}
}